<?php
    include "db.php";
    
    class Forum
    {
         var $content;

         var $name_template;
         var $path_template;

         var $all_topics;
         var $all_answers;

         var $pages_topics;
         var $pages_answers;
         
         var $cur_page_topic;
         var $cur_page_answer;

         var $forum;

         function Forum($mass_settings)
         {
            $this->forum = new forum_db($mass_settings);
            
            $this->all_topics = array();
            $this->all_answers = array();
            
            $this->array_defines_text=
                array(
                      "Topics" => Topics,
                      "New_topic" => New_topic,
                      "Search" => Search,
                      "Topic" => Topic,
                      "Answers" => Answers,
                      "Last_post" => Last_post,
                      "Page" => Page,
                      "topic_form" => topic_form,
                      "nick" => nick,
                      "content" => content,
                      "signature" => signature,
                      "link" => link,
                      "save" => save,
                      "Word" => Word,
                      "Search_answers_too" => Search_answers_too,
                      "Answer" => Answer,
                      "Page_answers" => Page_answers,
                      "Search_" => Search_,
                      "alert_wrong_word_search"=>alert_wrong_word_search,
                      "alert_wrong_nick_new_topic" =>    alert_wrong_nick_new_topic,
                      "alert_wrong_topic_new_topic" =>   alert_wrong_topic_new_topic,
                      "alert_wrong_content_new_topic" => alert_wrong_content_new_topic,
                      "alert_wrong_url" => alert_wrong_url,
                      "confirm_del_forum" => confirm_del_forum,
                      "save_" => save_,
                      "topic_not_found" => topic_not_found,

                      "list_answers" => "",
                      "topic_name" => "",
                      "id_topic" => "",
                      "list_topics" => "",

                      "WIDTH"           => $mass_settings["width_module"],
                      "css_topics"      => $mass_settings["css_topics"],
                      "css_new_topic"   => $mass_settings["css_new_topic"],
                      "css_search"      => $mass_settings["css_search"],
                      "css_topic"       => $mass_settings["css_topic"],
                      "count_mess"      => $mass_settings["count_mess"],
                      "mod_id"          => $mass_settings["module_id"],

                      'forum_edit' => forum_edit,
                      'forum_delete' => forum_delete,
                     
                      "" => ""
                 );
             $this->content="";
             $this->path_template="templates/";
         }

         function head($mass_vars)
         {
            $this->cur_page_topic  = intval($mass_vars["page_number"]);
            $this->cur_page_answer = intval($mass_vars["page_number_answers"]);
            
            switch($mass_vars["action"])
            {
               case "new_topic":
                    $this->name_template="new_topic.tmpl";
                    break;
                    
               case "search":
                    $this->name_template="search.tmpl";
                    break;
                    
               case "del_mess":
                    $this->delete_mess($mass_vars["user_id"],$mass_vars["id_topic"]);
                    //$mass_vars["page_number_answers"] = $this->getCurPageAnswers($mass_vars["id_topic"]);
                    $this->name_template="topic.tmpl";
                    $this->array_defines_text["page_number_answers"] = $this->cur_page_answer;
                    $this->array_defines_text["id_topic"] = intval($mass_vars["id_topic"]);
                    $this->getAnswers($mass_vars["id_topic"]);
                    $this->getPagesAnswers($mass_vars["id_topic"]);
                    break;
                    
               case "edit_mess":
                    $this->edit_mess($mass_vars);
                    $this->name_template="topic.tmpl";
                    $this->array_defines_text["page_number_answers"] = $mass_vars["page_number_answers"];
                    $this->array_defines_text["id_topic"]=intval($mass_vars["id_topic"]);
                    $this->getAnswers($mass_vars["id_topic"]);
                    $this->getPagesAnswers($mass_vars["id_topic"]);
                    break;

               case "add_answer_topic":
                    $this->add_new_answer($mass_vars);

               case "answer_topic":
                    $this->name_template="topic.tmpl";
                    $this->array_defines_text["page_number_answers"] = $this->cur_page_answer;
                    $this->array_defines_text["id_topic"] = intval($mass_vars["id_topic"]);
                    $this->getAnswers($mass_vars["id_topic"]);
                    $this->getPagesAnswers($mass_vars["id_topic"]);
                    break;

               case "after_search":
                    $this->name_template="topics.tmpl";
                    $this->getTopicsSearch($mass_vars["word"],$mass_vars["answers"]);
                    break;

               case "add_new_topic":
                    $this->add_new_topic($mass_vars);
                    
               default:
                    $this->name_template="topics.tmpl";
                    $this->getTopics();
                    $this->getPagesTopics();
            }
            $this->tmpl();
         }
         
         function getTopics()
         {
            $this->all_topics = $this->forum->getTopics();

            $this->pages_topics = sizeof($this->all_topics);
            
            $begin = ($this->cur_page_topic-1)*$this->array_defines_text["count_mess"];
            $copy_all_topics=$this->all_topics;

            if($copy_all_topics=="") return;
            $copy_all_topics = array_slice($copy_all_topics,$begin,$this->array_defines_text["count_mess"]);

            foreach($copy_all_topics as $k => $value)
            {
                         $this->array_defines_text["list_topics"].= "<tr><td class='tr_topic_ans_topics' style='width:70%;'><a href='#' class='topics' onclick='go_topic(\"answer_topic\",".$value[0]."); return false;'>".$value[1].
                                           "</a></td><td class='tr_topic_ans_topics' style='width:5%;'><span class='answers_topics'><div align='center'>".$value[6].
                                           "</span></td><td class='tr_last_post_topics' style='width:25%;'><span class='data_topics'><div align='center'>".date("Y-m-d",intval($value[0]))." ".date("H:i:s",intval($value[0]))."</span></td></tr>";
            }
         }
         
         function getPagesTopics()
         {
             $count = $this->pages_topics;
             $kol_page = $count/$this->array_defines_text["count_mess"];
             
             if($kol_page<intval($count/$this->array_defines_text["count_mess"]))
                $kol_page = $kol_page -1;

             else if($kol_page>intval($count/$this->array_defines_text["count_mess"]))
                $kol_page = $kol_page + 1;

             for($i=1; $i<=$kol_page; $i++){
                  if($i==$this->cur_page_topic)
                     $this->array_defines_text["Page"].= "|<b>".$i."</b>| ";
                  else
                     $this->array_defines_text["Page"].= "|<a href='#' onclick='setPage(".$i."); return false;' class='page'>".$i."</a>| ";
             }
         }
         
         function add_new_topic($mass_vars)
         {
            $this->forum->addTopic($mass_vars);
         }
         
         function getAnswers($id_topic)
         {
            $begin = ($this->cur_page_answer-1)*$this->array_defines_text["count_mess"];
            
            $topics = $this->forum->getTopicById($id_topic);

            if(!sizeof($this->all_answers))  $this->all_answers = $this->forum->getAnswersByTopic($id_topic);

            $this->pages_answers = sizeof($this->all_answers);
            
            $this->array_defines_text["topic_name"] = "<span class='content'>Topic: <b>".$topics[1]."</b></span>";

            if($this->cur_page_answer==1){
                $this->array_defines_text["list_answers"].="<tr><td class='tr_answer_topic' width='25%' valign='top'><span class='nick'>".$topics[2]."</span><br><br><span class='data'>".date("Y-m-d",intval($topics[0]))."&nbsp; ".date("H:i:s",intval($topics[0]))."</span></td>
                     <td class='tr_answer_topic' width='75%' valign='top'><span class='content'>".$topics[3]."<br><br>";
                     if(isset($topics[5]) && $topics[5]!="")
                        $this->array_defines_text["list_answers"].="<span class='strel'><b> >> </b></span> <a href='#' onclick='javascript: window.open(\"http://".$topics[5]."\"); return false;' class='link'> ".$topics[5]."</a><br><br>";
                     if(isset($topics[4]) && $topics[4]!="")
                        $this->array_defines_text["list_answers"].="------------------------------------------------------------<br>".$topics[4];
                     $this->array_defines_text["list_answers"].="</span></td></tr>";
            }

            $copy_all_answers  = $this->all_answers;

            if($copy_all_answers=="") return;
            $copy_all_answers = array_slice($copy_all_answers,$begin,$this->array_defines_text["count_mess"]);
            
            $this->get_answers_topic($copy_all_answers);
         }
         
         function get_answers_topic($copy_all_answers)
         {
            foreach($copy_all_answers as $k => $value)
            {
                $this->array_defines_text["list_answers"].="<tr><td class='tr_answer_topic' width='25%' valign='top'><span class='nick'>".$value[2]."</span><br><br><span class='data'>".date("Y-m-d",intval($value[0]))."&nbsp; ".date("H:i:s",intval($value[0]))."</span></td>
                <td class='tr_answer_topic' width='75%' valign='top'>
                     <table width='100%' cellpadding='0' cellspacing='0' border='0' align='left'>
                        <tr>
                          <td align='right' valign='top' width='100%'>";
                          if(session_id()==$value[6]){
                             $this->array_defines_text["list_answers"].="
                             <a href='#' class='link' onclick='edit_mess(\"".$value[0]."\",".$this->cur_page_answer.",\"".checkString_forum($value[2])."\",\"".checkString_forum($value[3])."\",\"".checkString_forum($value[4])."\",\"".checkString_forum($value[5])."\"); return false;'>".$this->array_defines_text['forum_edit']."</a>
                             <a href='#' class='link' onclick='del_mess(\"".$value[0]."\",".$this->cur_page_answer."); return false;'>".$this->array_defines_text['forum_delete']."</a>";
                          }
                $this->array_defines_text["list_answers"].="
                          </td></tr><tr><td align='left' valign='top' width='100%'>
                <span class='content'>".$value[3]."<br><br>";
                if(isset($value[5]) && $value[5]!="")
                   $this->array_defines_text["list_answers"].="<span class='strel'><b> >> </b></span> <a href='#' onclick='javascript: window.open(\"http://".$value[5]."\"); return false;' class='link'> ".$value[5]."</a><br><br>";
                if(isset($value[4]) && $value[4]!="")
                   $this->array_defines_text["list_answers"].="------------------------------------------------------------<br>".$value[4];
                   $this->array_defines_text["list_answers"].="</td></tr></table></span></td></tr></td></tr>";
            }
         }
         
         function getPagesAnswers($id_topic)
         {
             $count = $this->pages_answers;
             
             if(!$count) $count=1;
             $kol_page = $count/$this->array_defines_text["count_mess"];
             
             if($kol_page<intval($count/$this->array_defines_text["count_mess"]))
                $kol_page = $kol_page -1;
                
             else if($kol_page>intval($count/$this->array_defines_text["count_mess"]))
                $kol_page = $kol_page + 1;

             for($i=1; $i<=$kol_page; $i++)
             {
	              if($i==$this->cur_page_answer)
                     $this->array_defines_text["Page_answers"].= "|<b>".$i."</b>| ";
                  else
                     $this->array_defines_text["Page_answers"].= "|<a href='#' onclick='setPage(".$i."); return false;' class='page_answer'>".$i."</a>| ";
             }
         }
         
         function add_new_answer($mass_vars)
         {
            $content_answers = array(time(),$mass_vars["id_topic"],$mass_vars["nick"],$mass_vars["content"],$mass_vars["signature"],$mass_vars["link"],session_id());
            $this->forum->add_new_answer($content_answers);
            if(!sizeof($this->all_answers))
			 {
				$this->all_answers = $this->forum->getAnswersByTopic($mass_vars["id_topic"]);
			 }
			$answersNumber = sizeof($this->all_answers);
			
            if ($this->cur_page_answer * $this->array_defines_text["count_mess"] < $answersNumber)
			 {
				if (($answersNumber%$this->array_defines_text["count_mess"])==0) {
					$this->cur_page_answer = $answersNumber/$this->array_defines_text["count_mess"];
				}else {
					$this->cur_page_answer = intval($answersNumber/$this->array_defines_text["count_mess"])+1;
				}
			 };
         }
         
         function delete_mess($answer_id,$topic_id)
         {
            $this->forum->delete_answer($answer_id,$topic_id);
            if(!sizeof($this->all_answers))
			 {
				$this->all_answers = $this->forum->getAnswersByTopic($topic_id);
			 }
			$answersNumber = sizeof($this->all_answers);
            if (($this->cur_page_answer - 1) * $this->array_defines_text["count_mess"] >= $answersNumber && $this->cur_page_answer > 1)
			 {
				$this->cur_page_answer--;
			 };
         }

         function edit_mess($mass_vars)
         {
            $this->forum->edit_answer($mass_vars);
         }
         
         function getTopicsSearch($word, $search_answers)
         {
            $index=0;
            $this->all_topics = $this->forum->getTopics();
            
            if($this->all_topics==""){
                 $this->array_defines_text["list_topics"] = "<tr><td colspan='3'><b>".$this->array_defines_text["topic_not_found"]."</b></td></tr>";
                 return;
            }
            $key=array();
            if(isset($search_answers) && $search_answers!=""){
                 $this->all_answers = $this->forum->getAllAnswers();
                 if($this->all_answers!="")
                   foreach($this->all_answers as $k => $value) {
                      if( strstr(strtolower($value[3]),strtolower($word)) ){
                         $key[$index] = $value[1];
                         $index++;
                      }
                   }
            }
            $key = array_flip($key);
            foreach($this->all_topics as $k => $value)
            {
                if( strstr(strtolower($value[1]),strtolower($word)) || strstr(strtolower($value[3]),strtolower($word)) || (sizeof($key)!=0 && array_key_exists($value[0],$key)) ) {
                    $this->array_defines_text["list_topics"].= "<tr><td class='tr_topic_ans_topics'><a href='#' class='topics' onclick='go_topic(\"answer_topic\",".$value[0]."); return false;'>".$value[1].
                              "</a></td><td class='tr_topic_ans_topics'><span class='answers_topics'><div align='center'>".$value[6].
                              "</span></td><td class='tr_last_post_topics'><span class='data_topics'><div align='center'>".date("Y-m-d",intval($value[0]))." ".date("H:i:s",intval($value[0]))."</span></td></tr>";
                    $index++;
                }
            }
            if(!$index)
                $this->array_defines_text["list_topics"] = "<tr><td colspan='3'><b>".$this->array_defines_text["topic_not_found"]."</b></td></tr>";
            $this->array_defines_text["Page"].= "|<b>1</b>| ";
         }

         function show()
         {
            echo $this->content;
         }

         function tmpl()
         {
            if(!is_readable($this->path_template.$this->name_template))
               echo "error";

            $b=implode("",file($this->path_template.$this->name_template));

            foreach($this->array_defines_text as $k => $v)
            {
                $b=str_replace("{\$".$k."}",$v,$b);
            }
            $this->content.=$b;
         }
         
         function CloseDb()
         {
         	$this->forum->close_db();
         }
    }
?>