<?php
	class MigrationForum2_0 {
		var $success;
		var $mass_settings;
		
		function MigrationForum2_0($mass_settings) {
			$this->success = false;
			$this->mass_settings = $mass_settings;
		}
		
		function MigrationContentFR2_0() {
			include_once 'classes/config.php';
			if(!defined('source')){
				$this->success = false;
				return;
			}
			switch (strtolower(source)) {
				case 'files':
					 $topics_content = $this->MigrationContentFilesFR2_0('classes/topics.txt');
					 $answers_content = $this->MigrationContentFilesFR2_0('classes/answers.txt');
					 break;
				case 'mysql':
					 if(!defined('mysql_host') || !defined('mysql_user') || !defined('mysql_password') || !defined('mysql_database_name')){
					 	return;
					 }
					 //$this->MigrationContentMysqlGB2_0(mysql_host, mysql_user, mysql_password, mysql_database_name);
					 break;
				case 'sqlite':
					 //
					 //$old_content = $this->MigrationContentSqliteFilesGB2_0('dump');
					 return;
					 break;
				default: 
				     $this->success = false;
				     return;	
			}
			
			if($this->success){
				 $this->MigrationContentFR2_1($topics_content, $answers_content);
			}
		}
		
		function MigrationContentFilesFR2_0($old_path) {
			if(!file_exists($old_path)){
				$this->success = false;
			}
			
			$file_content = implode('',file($old_path));
			$this->success = true;
			return unserialize($file_content);
		}
		
		function MigrationContentFR2_1($topics_content, $answers_content) {
			switch ($this->mass_settings['type_db'])	{
				case 'files':
					$this->MigrationContentFilesFR2_1($topics_content, $answers_content);
					break;
				case 'sqlite':
					$this->MigrationContentSqliteFR2_1($topics_content, $answers_content);
					break;
				case 'mysql':
					$this->MigrationContentMysqlFR2_1($topics_content, $answers_content);
					break;
			}
		}
		
		function MigrationContentFilesFR2_1($topics_content, $answers_content) {
			$topics_content = serialize($topics_content);
			$answers_content = serialize($answers_content);
			$dataDir = '../data/';
			if (!file_exists($dataDir)) {
				mkdir($dataDir);
				chmod($dataDir, 0777);
			}
			$fp = fopen($dataDir.$GLOBALS['mass_settings']['module_id'].'_topics.txt', 'w');
			fwrite($fp, $topics_content);
			fclose($fp);
			
			$fp = fopen($dataDir.$GLOBALS['mass_settings']['module_id'].'_answers.txt', 'w');
			fwrite($fp, $answers_content);
			fclose($fp);
		}
		
		function MigrationContentSqliteFR2_1($topics_content, $answers_content) {
			$con = sqlite_open('../data/'.$GLOBALS['mass_settings']['module_id'].'.bin');
			if (!$con) {
				return false;
			}
	        foreach($topics_content as $name => $value) {
            	$sql = "INSERT INTO ".$this->mass_settings['module_id']."_list_topics(time_create, name_topic, nick, content, signature, link, count_answers, sess_id)
            			VALUES('".$value[0]."', '".$value[1]."', '".$value[2]."', '".$value[3]."', '".$value[4]."', '".$value[5]."', '".$value[6]."', '".$value[7]."')";
            	sqlite_query($sql);
            }
            
            foreach($answers_content as $name => $value) {
            	$sql = "INSERT INTO ".$this->mass_settings['module_id']."_list_answers(time_create, id_topic, nick, content, signature, sess_id)
            			VALUES('".$value[0]."', '".$value[1]."', '".$value[2]."', '".$value[3]."', '".$value[4]."', '".$value[5]."', '".$value[6]."')";
            	sqlite_query($sql);
            }
			sqlite_close($con);
		}
		
		function MigrationContentMysqlFR2_1($topics_content, $answers_content) {
			$con = @mysql_connect($this->mass_settings['host_db'], $this->mass_settings['user_db'], $this->mass_settings['passwd_db']);
			if (!$con) {
				return false;
			}
			if (!mysql_select_db($this->mass_settings['db_name'])) {
				return false;
			}
            foreach ($topics_content as $name => $value) {
            	$sql = "INSERT INTO ".$this->mass_settings['module_id']."_list_topics(time_create, name_topic, nick, content, signature, link, count_answers, sess_id)
            			VALUES('".$value[0]."', '".$value[1]."', '".$value[2]."', '".$value[3]."', '".$value[4]."', '".$value[5]."', '".$value[6]."', '".$value[7]."')";
            	mysql_query($sql);
            }
            foreach ($answers_content as $name => $value) {
            	$sql = "INSERT INTO ".$this->mass_settings['module_id']."_list_answers(time_create, id_topic, nick, content, signature, sess_id)
            			VALUES('".$value[0]."', '".$value[1]."', '".$value[2]."', '".$value[3]."', '".$value[4]."', '".$value[5]."', '".$value[6]."')";
            	mysql_query($sql);
            }
			mysql_close($con);
		}
		
	}
	
	function MigrationForum2_0($mass_settings) {
		if (isset($mass_settings['module_id']) && file_exists('classes/config.php') && !file_exists('../data/'.$mass_settings['module_id'].'.migrationforum.txt')) {
			$mig_obj = new MigrationForum2_0($mass_settings);
			$mig_obj->MigrationContentFR2_0();
			$fp = fopen('../data/'.$mass_settings['module_id'].'.migrationforum.txt', 'w');
			fwrite($fp,'true');
			fclose($fp);
		}
	}

?>